; main.s
; Desenvolvido para a placa EK-TM4C1294XL
; Ex4: Uso de GPIO com interrupao
; Prof. Guilherme de S. Peron	- 12/03/2018
; Prof. Marcos E. P. Monteiro	- 12/03/2018
; Prof. DaLuz           		- 25/02/2022

;################################################################################
; Este programa espera o usurio apertar a chave USR_SW1 e/ou a chave USR_SW2.
; Caso o usurio pressione a chave USR_SW1, acender o LED2. Caso o usurio pressione 
; a chave USR_SW2, acender o LED1. Caso as duas chaves sejam pressionadas, os dois 
; LEDs acendem.
;################################################################################

;################################################################################
        THUMB                        ; Instrues do tipo Thumb-2
;################################################################################
; Definies de Valores
BIT0	EQU 2_0001
BIT1	EQU 2_0010
;################################################################################
; rea de Dados - Declaraes de variveis
		AREA  DATA, ALIGN=2
		; Se alguma varivel for chamada em outro arquivo
		;EXPORT  <var> [DATA,SIZE=<tam>]   ; Permite chamar a varivel <var> a 
		                                   ; partir de outro arquivo
;<var>	SPACE <tam>                        ; Declara uma varivel de nome <var>
                                           ; de <tam> bytes a partir da primeira 
                                           ; posio da RAM		
;################################################################################
; rea de Cdigo - Tudo abaixo da diretiva a seguir ser armazenado na memria de 
;                  cdigo
        AREA    |.text|, CODE, READONLY, ALIGN=2

		; Se alguma funo do arquivo for chamada em outro arquivo	
        EXPORT Start                ; Permite chamar a funo Start a partir de 
			                        ; outro arquivo. No caso startup.s
									
		; Se chamar alguma funo externa	
        ;IMPORT <func>              ; Permite chamar dentro deste arquivo uma 
									; funo <func>
		IMPORT  GPIO_Init
        IMPORT  PortN_Output
        IMPORT  PortJ_Input
;################################################################################
; Funo main()
Start  			
	BL		GPIO_Init					;Chama a subrotina que inicializa os GPIO

MainLoop
	CMP		R4, #1						;Passou pela IRQ?
	BEQ		IRQAtivada					;Sim: ==> Tratar o retorno da IRQ
	B		MainLoop					;Volta para o lao principal	
IRQAtivada
	CMP		R5,#1						;Boto pressionado SW1 Brd Subida
	BEQ		ApagaLed					;
	CMP		R5,#3						;Boto pressionado SW2 Brd descida
	BEQ		LigaLed						;
	B		MainLoop					;outros casos de botes no tratar
LigaLed	
	MOV		R4,#0						;Flag=0
	MOV		R0,#1						;Led ON
	BL		PortN_Output				;Liga Led
	B		MainLoop
ApagaLed
	MOV		R4,#0						;Flag=0
	MOV		R0,#0						;Led OFF
	BL		PortN_Output				;Desliga Led
	B		MainLoop

    ALIGN                        		;Garante que o fim da seo est alinhada 
    END                          		;Fim do arquivo